from PASTEC.DecisionMakerPerConsensus import DecisionMakerPerConsensus
from PASTEC.OutputWriterPerConsensus import OutputWriterPerConsensus
from PASTEC.utils.AgentFactory import AgentFactory
from commons.core.sql.DbFactory import DbFactory

#TODO: check tables according to config ?
class SuperAgent(object):
 
    def __init__(self, env):
        self._environment = env
        
    def launchAllAgents(self):
        #TODO: allow to give a configFileName
        self._environment.setDbInstance(DbFactory.createInstance())
        lCreatedRetrieverNames = AgentFactory.generateRetrieverResultsAndGetRetrieverNames(self._environment)
        self._environment.getDbInstance().close()
        AgentFactory.generateClassifierResults(self._environment, lCreatedRetrieverNames)
        
    def live(self):
        lConsensusNames = self._environment.getConsensusNameList()
        lResults = self.getAnalysesResults()
        outFileName = "%s.classif" % self._environment.getProjectName()
        outF = open(outFileName, "w")
        dConsensusName2Results = self.createDictOfListOfResultsPerConsensusName(lResults)
        for consensusName in lConsensusNames:
            consensusLength = self._environment.getConsensusLength(consensusName)
            dResults2Write = self.decidePerConsensus(consensusName, dConsensusName2Results[consensusName], consensusLength)
            self.outputWriter(outF, dResults2Write)
        outF.close()

    def getAnalysesResults(self):
        lResults = []
        for agent in AgentFactory.getClassifierNamesList():
            lResults.extend(self._environment.getResultsOfOneAgent(agent))
        return lResults    
    
    def createDictOfListOfResultsPerConsensusName(self, lResults):
        lResultsSorted = sorted(lResults, key=lambda k: k.message['consensusName'])
        dConsensusName2Results = {}
        previousConsensusName = ""
        lResultOfConsensusName = []
        for result in lResultsSorted:                        
            currentConsensusName = result.message['consensusName']
            if currentConsensusName != previousConsensusName and lResultsSorted.index(result) != 0:
                dConsensusName2Results[previousConsensusName] = lResultOfConsensusName
                lResultOfConsensusName = []
            lResultOfConsensusName.append(result)
            previousConsensusName = currentConsensusName
            if lResultsSorted.index(result) == len(lResultsSorted) - 1:
                dConsensusName2Results[previousConsensusName] = lResultOfConsensusName
         
        return dConsensusName2Results
    
    def decidePerConsensus(self, consensusName, lResults, consensusLength):  
        decisionMaker = DecisionMakerPerConsensus(self._environment)
        d2Return = decisionMaker.decidePerConsensus(consensusName, lResults, str(consensusLength))
        return d2Return
    
    def outputWriter(self, outF, dResult):
        outputWriter = OutputWriterPerConsensus()
        outputWriter.outputWriter(outF, dResult)
