#! /usr/bin/env python


import optparse, os, sys, subprocess, tempfile, shutil, tarfile, random
from optparse import OptionParser

def stop_err(msg):
	sys.stderr.write('%s\n' % msg)
	sys.exit()

def __main__():
	#Parse Command Line
	parser = optparse.OptionParser()
	parser.add_option("-i", "--input", dest="inputFile", help="input tar file.")
	parser.add_option("-o", "--output", dest="outputFile", help="Out tar file.")
	(options, args) = parser.parse_args()

	inputFileNames = []
	outCountNames = []
	tar = tarfile.open(options.inputFile, "r")
	workingDir = os.getcwd()
	for tarinfo in tar:	
			name = tarinfo.name
			root = os.path.basename(name).split(".")[0]
			tar.extract(name)
			workingDir = os.getcwd()
			inputFileNames.append("%s/%s" % (workingDir, name))
			outCountNames.append("%s/%s_overlapOut.csv" % (workingDir, root))
	tar.close()


	#Construct the lines commands
	cmds = []
	for i in range(len(inputFileNames)):
		cmd = "python %s/SMART/DiffExpAnal/countNumber.py " %  os.environ["REPET_PATH"]		
		opts = "-i %s -o %s " % (inputFileNames[i], outCountNames[i])
		cmd += opts
		cmds.append(cmd)

	tmp_files = []
	for i in range(len(cmds)):
		try:
			tmp_out = tempfile.NamedTemporaryFile().name
			tmp_files.append(tmp_out)
			tmp_stdout = open(tmp_out, 'wb')
			tmp_err = tempfile.NamedTemporaryFile().name
			tmp_files.append(tmp_err)
			tmp_stderr = open(tmp_err, 'wb')
			proc = subprocess.Popen(args=cmds[i], shell=True, cwd=".", stdout=tmp_stdout, stderr=tmp_stderr)
			returncode = proc.wait()
			tmp_stderr.close()
			#get stderr, allowing for case where it's very large
			tmp_stderr = open(tmp_err, 'rb')
			stderr = ''
			buffsize = 1048576
			try:
				while True:
					stderr += tmp_stderr.read(buffsize)
					if not stderr or len(stderr) % buffsize != 0:
						break
			except OverflowError:
				pass
			tmp_stdout.close()
			tmp_stderr.close()
			if returncode != 0:
				raise Exception, stderr
		except Exception, e:
			stop_err('Error in :\n' + str(e))
	

	for tmp_file in tmp_files:
		os.remove(tmp_file)
		
	tar = tarfile.open(options.outputFile, "w")
	for fileName in outCountNames:
		tar.add(os.path.basename(fileName))
	tar.close()

if __name__=="__main__":__main__()
