#!/usr/bin/env python

import optparse, sys, tarfile


class loadMultiFastqFiles(object):
    
    
    def __init__(self):
        self._input = ""
        self._output = ""
        self._paired = None
        
    def _setAttributesFromOptions(self, options):
        self._output = options.outputSingleFile
        self._paired = options.outputPaireFile
        if self._paired == False:
            self._input = sys.argv[4:]
        else:
            self._input = sys.argv[5:]
    
    def setAttributesFromCmdLine(self):
        parser = optparse.OptionParser()
        parser.add_option('-i', '--inputs', dest='inputFiles', default=None, help='several input files. (seperated by @ or @@' )
        parser.add_option( '-o', '--output', dest='outputSingleFile', default=None, help='The output list of fastq files on tar format.' )
        parser.add_option( '', '--pairedEnd', dest='outputPaireFile', default=False, action = "store_true", help='paired end option help to upload the corresponding paired end complementary fastq files' )
        ( options, args ) = parser.parse_args()
        self._setAttributesFromOptions(options)
        
    def run(self):
        tar = tarfile.open(self._output, "w")
        groupCount = 1
        fileCount = 0 
        

        i = 0
        while i < (len(self._input)-1):
            if self._input[i] == "@@":
                i += 1
                tar.add(self._input[i], arcname="Group%s_%s_paired.fastq" % (groupCount, fileCount))
            elif self._input[i] == "@":
                i += 1
                fileCount = 1
                groupCount += 1
                tar.add(self._input[i], arcname="Group%s_%s.fastq" % (groupCount, fileCount))
            else:
                fileCount += 1 
                tar.add(self._input[i], arcname="Group%s_%s.fastq" % (groupCount, fileCount))
            i +=1
        tar.close()




if __name__ == "__main__":
    iLaunch = loadMultiFastqFiles()
    iLaunch.setAttributesFromCmdLine()
    iLaunch.run()
