from PASTEC.utils.AbstractClassifierAgent import AbstractClassifierAgent
from PASTEC.Decision import Condition, NumericRule

class HG_BLRnAdaptatorAgent(AbstractClassifierAgent):


    
    def __init__(self, env):
        AbstractClassifierAgent.__init__(self, env)
        self._listOfKnownAgents = ["HG_BLRn_Agent"]
        self.CONDITIONS = {"classif_other":  [Condition([NumericRule(self._environment.getMinHGCoverage(), ">")]),
                                              Condition([NumericRule(self._environment.getMinHGIdentity(), ">")])],
                          "classif_BM":     [],
                          "weighting":      []}            
    def getAgentName(self):
        return "PotentialHostGene"
        
    def makeAppropriateConclusionsForHG_BLRn_Agent(self, iDemandAndResult):
        if iDemandAndResult and iDemandAndResult.result:
            iBM = iDemandAndResult.result
            self._dNumericData["coverage"].append(iBM.getCoverage())
            self._dNumericData["identity"].append(iBM.getIdentity())
            self._conclusionsMatch.append({'HG': iBM})
            
    def decide(self):
        lOtherConditions = self.CONDITIONS["classif_other"]
        if self._dNumericData and self._dNumericData["coverage"] and self._dNumericData["identity"] and lOtherConditions[0].validate([self._dNumericData["coverage"][0]]) and lOtherConditions[1].validate([self._dNumericData["identity"][0]]):
            self._classification = self.getAgentName()
            self._CI += 1
        
        normalizedIC = self._normalizeIC()
        return self._classification, normalizedIC
