from PASTEC.utils.AbstractClassifierAgent import AbstractClassifierAgent
from PASTEC.Decision import Condition, NumericRule, PresenceRule
from PASTEC.Demand import Demand
import re

class SINE_Agent(AbstractClassifierAgent):

    def __init__(self, env):
        AbstractClassifierAgent.__init__(self, env)
        self._listOfKnownAgents = ["Size_Agent", "TE_BLRx_Agent", "TE_BLRtx_Agent", "PolyA_Agent", "SSRtrf_Agent"]
    
    def getAgentName(self):
        return "SINE"
    
    def makeAppropriateConclusionsForPolyA_Agent(self, iDemandAndResult):
        if iDemandAndResult != None and iDemandAndResult.result != None:
            iPolyATail = iDemandAndResult.result
            if iPolyATail.isTailPresent():
                self._conclusionsSearch.append(str(iPolyATail))
                self._dPresenceData["classif_other"].append(str(iPolyATail))
                
    def makeAppropriateConclusionsForSSRtrf_Agent(self, iDemandAndResult):
        if iDemandAndResult != None and iDemandAndResult.result != None:
            iSSRCollection = iDemandAndResult.result
            if not iSSRCollection.isEmpty():
                for iSSR in iSSRCollection.getSSRList():
                    self._conclusionsSearch.append(str(iSSR))
                    self._dPresenceData["classif_other"].append(str(iSSR))
                    
    ## Get and filter analysis if corresponding table is in database.
    #
    def getAnalysesResults(self, demand):
        for agentName in self._listOfKnownAgents:
            iDemand = Demand(agentName, demand.consensusName)
            iAgentResult = self._environment.getResultAccordingToDemand(iDemand)
            method2Call = "self.makeAppropriateConclusionsFor%s( iAgentResult )" % agentName
            exec ( method2Call )
        for conclusion in self._conclusionsSearch:
            if re.match('\(A\)\d+_end', conclusion) and 'polyAtail' in self._conclusionsSearch:
                self._conclusionsSearch.remove(conclusion)
        #TODO: refactoring and bug fixed => all pattern have to be handled
        for conclusion in self._dPresenceData["classif_other"]:
            if re.match('\(A\)\d+_end', conclusion) and 'polyAtail' in self._dPresenceData["classif_other"]:
                self._dPresenceData["classif_other"].remove(conclusion)