import os
import glob
import ConfigParser
import pyRepet.launcher.programLauncher

from pyRepet.util.file.FileUtils import *


class LauncherBlasterNotInParallel:

    def __init__(self):
        self._queryInputFolder = ""
        self._subjectInputSequence = ""
        self._outputFileList = []
        self._program = ""
        self._programLauncherInstance = pyRepet.launcher.programLauncher.programLauncher()
        self._configFile = ""
      
    def _isQueryInputFolderEmpty(self, fileListInDir):
        return len(fileListInDir) == 0
    
    def setQueryInputFolder(self, input):
         self._queryInputFolder = input;

    def setSubjectInputSequence(self, input):
         self._subjectInputSequence = input;
    
    def setProgram(self, program):
         self._program = program;
        
    def setConfigFile (self, configFile):
        self._configFile = configFile
    
    def checkQueryInputFolder(self):
        fileUtils = FileUtils()
        
        if (not fileUtils.isRessourceExists(self._queryInputFolder)):
            return 0
        
        fileListInDir = fileUtils.listDir(self._queryInputFolder) 
        
        if (self._isQueryInputFolderEmpty(fileListInDir)):
            return 0
        
        for file in fileListInDir:
            dirfile = os.path.join(file)
            if (self._checkFileExitsAndNotEmpty(dirfile) != 1):
                return 0
        return 1
    
    def checkSubjectInputSequence(self):
        return self._checkFileExitsAndNotEmpty(self._subjectInputSequence)
    
    def checkOutputFileList (self):
        fileUtils = FileUtils()
        for file in self._outputFileList:
            if not fileUtils.isRessourceExists(file):
                return 0
        return 1   
    
    def addOutputFile(self, file):
        self._outputFileList.append(file); 
    
    def checkProgram (self):
        fileUtils = FileUtils() 
        if fileUtils.isRessourceExists(self._program):
            return 1
        return 0
        
    def _checkFileExitsAndNotEmpty(self, fileName):
        fileUtils = FileUtils() 
        if fileUtils.isRessourceExists(fileName) and not fileUtils.isFileEmpty(fileName):
            return 1
        return 0
    
    def run(self):
          config = ConfigParser.ConfigParser()
          config.readfp( open(self._configFile) )
          self._programLauncherInstance.reset( self._subjectInputSequence )
          self._programLauncherInstance.launchBlaster( allByAll="yes",
                              evalFilter=config.get("self_align","Evalue"),
                              idFilter=config.get("self_align","identity"),
                              lgthFilter=config.get("self_align","length"),
                              outPrefix=self._queryInputFolder )
          
  

if __name__ == "__main__":                 
    main() 
